//*********************************************************************************
// rescue.sqf
// this script is activated only when the chopper is heavily damaged and make
// an emergency landing but it will not blow up
//*********************************************************************************

//wait the chopper to touch ground
waitUntil{(getPosATL MM_CHOPPER) select 2 < 0.5};

if( (alive MM_CHOPPER) && (((getDammage MM_CHOPPER) > 0 || (fuel MM_CHOPPER) == 0) || !(alive MM_PILOT1)) && MM_AVVIONE != 1) then{ //Medevac mission started
	
	// tell at the client that the rescue mission is started
	if (MM_SALVA == 1) then{
		MM_SALVA = 0;
	}
	else{
		MM_SALVA = 1;
	};
	publicVariable "MM_SALVA";
	
	//regive at these units to get damage
	MM_MEDIC allowDammage true;
	MM_GUNNR1 allowDammage true;
	MM_GUNNR2 allowDammage true;

	if(MM_COUNTER == 1) then{
		MM_PLAYER removeEventHandler ["Fired", MM_EH1];
		MM_COUNTER = 0;
	};	
	
	terminate MM_LAND;
	terminate MM_HEALER;
	terminate MM_CONTROLLO;
	terminate MM_REINSERTING;
	terminate MM_CLICK;
	terminate MM_DIS; 
	
	onMapSingleClick "";
	
	deleteMarker "MM_MKR3";
	
	deleteVehicle MM_HELIH2;
	
	//MM_CHOPPER removeAction MM_REINSERT;
	if (MM_RAZIONE == 1) then{
		MM_RAZIONE = 0;
	}
	else{
		MM_RAZIONE = 1;
	};
	publicVariable "MM_RAZIONE";
	
	MM_CHOPPER removeAction MM_ABOR;

	if(MM_CHOPPER in ((getMarkerPos "MM_MKR1") nearObjects ["All", 200])) then{ //crashed near the base
		
		MM_BASE = 1;
		publicVariable "MM_BASE";
		
		MM_MEDIC removeAllEventHandlers "killed";
		
			if(!alive MM_PILOT1) then{
				//PAPABEAR sideChat "The medevac's pilot is dead. We are trying to find a substitute, over";
				MM_TWELVE = 1;
				publicVariable "MM_TWELVE";
			}
			else{
				//PAPABEAR sideChat "The helo is crashed near the base. We are trying to repair it, over";
				MM_THIRTEEN = 1;
				publicVariable "MM_THIRTEEN";
			};

		//remove the abort action and set the status flag MM_AZZIONE
		if (MM_REMOVE == 1) then{
			MM_REMOVE = 0;
		}
		else{
			MM_REMOVE = 1;
		};
		publicVariable "MM_REMOVE";
		
		MM_PLAYER removeAction MM_AACTION;
		MM_AZZIONE = 0;
		
		//delete the beta's waypoints
		_way_count = waypoints MM_BETA;
		{ deleteWaypoint _x } forEach _way_count;
		
		
		//stop all the crews
		[MM_PILOT1, MM_GUNNR1, MM_GUNNR2, MM_PILOT3, MM_PILOT2] join MM_ALPHA;
		
		MM_AVVIONE = 1;
		publicVariable "MM_AVVIONE"; 

		sleep 50;
	
		//recreate the MM_BETA group
		if(side MM_PLAYER == west) then{
			MM_BETA = createGroup west;
			MM_PILOTS = createGroup west;
		}
		else{
			if(side MM_PLAYER == east) then{
				MM_BETA = createGroup east;
				MM_PILOTS = createGroup east;
			}	
			else{
				if(side MM_PLAYER == resistance) then{
					MM_BETA = creategroup resistance;
					MM_PILOTS = createGroup resistance;
				}
				else{
					MM_BETA = createGroup civilian;
					MM_PILOTS = createGroup civilian;
				};
			};
		};	
		
		//rejoin the MM_BETA group
		[MM_PILOT1, MM_GUNNR1, MM_GUNNR2] join MM_BETA;
		
		MM_PILOT1 disableAI "TARGET";
		MM_PILOT1 disableAI "AUTOTARGET";
		MM_PILOT1 setBehaviour "CARELESS";
		
		//rejoin the MM_PILOTS group
		[MM_PILOT2, MM_PILOT3] join MM_PILOTS;
		MM_PILOTS setCombatMode "RED";
		
	    _wp1 = MM_BETA addWaypoint [position MM_CHOPPER, 0]; //add a waypoint at the pilot to return to base
		_wp1 setWaypointType "MOVE";
		_wp1 setWaypointSpeed "FULL";
		_wp1 setWaypointBehaviour "COMBAT";
		

			if(!alive MM_PILOT1) then{
				//PAPABEAR sideChat "We have found a new pilot";
				MM_FOURTEEN = 1;
				publicVariable "MM_FOURTEEN";
			}
			else{
				//PAPABEAR sideChat "Medevac vehicle repaired";
				MM_FIFTEEN = 1;
				publicVariable "MM_FIFTEEN";
			};

		MM_CHOPPER setFuel 1;
		MM_CHOPPER setDammage 0;
		MM_RESORT = [] execVM "resort.sqf";
		MM_REINSERT = MM_CHOPPER addAction ["Reinsert", "dummy2.sqf"];
		if (MM_ARAZIONE == 1) then{
			MM_ARAZIONE = 0;
		}
		else{
			MM_ARAZIONE = 1;
		};
		publicVariable "MM_ARAZIONE";	
		
		if(MM_CISIAMO && !(MM_CHOPPER isKindOf "Helicopter")) then{
			MM_CONTROLLO = MM_CHOPPER execVM "controlling.sqf";
		};	
		
		MM_BASE = 0;
	}
	else{ //far from the FOB
		
		MM_EXPL = 1;
		publicVariable "MM_EXPL";
		
		//delete the RTB radio trigger
		//deleteVehicle MM_TRGGG1; 
		
		MM_PLAYER removeAction MM_AACTION;
		MM_AZZIONE = 0;
	
		MM_MEDIC removeAllEventHandlers "killed"; //remove all killed event handlers to the corpsman
		MM_CHOPPER removeAllEventHandlers "killed"; //remove all killed event handlers to the mh60s	

		[MM_PILOT1, MM_GUNNR1, MM_GUNNR2, MM_PILOT2, MM_PILOT3] join MM_ALPHA;
		
		deleteGroup MM_BETA;
		
		if(side MM_PLAYER == west) then{
			MM_BETA = createGroup west;
		}
		else{
			if(side MM_PLAYER == east) then{
				MM_BETA = createGroup east;
			}	
			else{
				if(side MM_PLAYER == resistance) then{
					MM_BETA = creategroup resistance;
				}
				else{
					MM_BETA = createGroup civilian;
				};
			};
		};	

		[MM_PILOT1, MM_PILOT2, MM_PILOT3, MM_GUNNR1, MM_GUNNR2, MM_MEDIC] join MM_BETA;
	
		_way_count = waypoints MM_BETA;
		{ deleteWaypoint _x } forEach _way_count;
	
		doStop [MM_PILOT1, MM_PILOT2, MM_PILOT3, MM_GUNNR1]; 
		
	    _wpresc = MM_BETA addWaypoint [position MM_CHOPPER, 0]; 
		_wpresc setWaypointType "MOVE";
		_wpresc setWaypointBehaviour "COMBAT";
		MM_BETA setCurrentWaypoint _wpresc;

		sleep 1;
		//sleep ((random 30) + 30);
	
		//PAPABEAR SideChat "Radio contact with medevac is lost.";
		MM_SIXTEEN = 1;
		publicVariable "MM_SIXTEEN";
		
		sleep 3;
		MM_POSRESC = mapGridPosition MM_CHOPPER;
		publicVariable "MM_POSRESC";
		MM_ORA = 1;
		publicVariable "MM_ORA";
		
		//PAPABEAR SideChat format["Last radio contact from position %1. Location marked on your map", MM_POSRESC];
		//_mkr = createMarker ["MM_MKR2", position MM_CHOPPER];
		//"MM_MKR2" setMarkerShape "ELLIPSE";
		//"MM_MKR2" setMarkerBrush "SOLID";
		//"MM_MKR2" setMarkerSize [80, 80];
		//"MM_MKR2" setMarkerColor "ColorRed";

		sleep 6;
		//PAPABEAR SideChat "Possibility of survivors. Check helo location if you can.";
		MM_SEVENTEEN = 1;
		publicVariable "MM_SEVENTEEN";
		
		//wait for the arrival of the player near the crash site
		waitUntil{MM_PLAYER in ((getMarkerPos "MM_MKR2") nearObjects ["CAManBase", 40])};

		//only if there are still some medevac's units
		if(count(units MM_BETA) > 0) then{
			{[_x] join (group MM_PLAYER)} forEach (units MM_BETA);
			[MM_MEDIC] join (group MM_PLAYER);
			
			if (MM_RESCUEMISSION == 1) then{
				MM_RESCUEMISSION = 0;
			}
			else{
				MM_RESCUEMISSION = 1;
			};
			publicVariable "MM_RESCUEMISSION";
		
			MM_DUMMYA = MM_PLAYER addAction ["",""];
			MM_RACTION = MM_PLAYER addAction ["Call for rescue", "rescue_m.sqf"];
			MM_RACTIVE = 1;
			sleep 1;
			MM_PLAYER removeAction MM_DUMMYA;
		};	
		MM_EXPL = 0;
	};
};


	
	